<?php

    namespace wpsg;

    /**
     * Model für eine Bestellung
     */
    class productgroup extends \wpsg_model {

        static $_tableName = 'WPSG_TBL_PRODUCTS_GROUP';

        public $data = null;

        /**
         * Lädt die Daten der Bestellung
         */
        public function load($productgroup_id) {

            $this->data = $this->db->fetchRow("SELECT * FROM `".constant(self::$_tableName)."` WHERE `id` = '".intval($productgroup_id)."' ");
            $this->id = $productgroup_id;

        }

        public function setImage(int $image_id) {

            $this->setMeta('image', $image_id);

        }

        public function getImage(): int {

            return intval($this->getMeta('image'));

        }

        public function getName(): string {

            return __($this->data['name'], 'wpsg');

        }

        public function getTemplate() {

			if ($this->data['template_file'] !== '0' && $this->data['template_file'] !== '') $template = $this->data['template_file']; else $template = false;

            return $template;

        }

        /**
         * @param $arFilter
         * @return \wpsg_product[]
         * @throws Exception
         */
        public function findProducts($arFilter = []) {

            $arFilter['productgroup_ids'] = [$this->getId()];

            return \wpsg_product::find($arFilter);

        }

        /**
         * @param $arFilter
         * @return productgroup[]
         * @throws Exception
         */
        public static function find($arFilter = []) {

            list($strQuerySELECT, $strQueryWHERE, $strQueryJOIN, $strQueryHAVING, $strQueryORDER) = self::getQueryParts($arFilter);

            $strLimit = "";

            if (wpsg_isSizedArray($arFilter['limit'])) $strLimit = "LIMIT ".wpsg_q($arFilter['limit'][0]).", ".wpsg_q($arFilter['limit'][1]);

            $strQuery = "
				SELECT
					PG.`id`
					".$strQuerySELECT."
				FROM
					`".constant(self::$_tableName)."` AS PG
					    ".$strQueryJOIN."
				WHERE
					1
					".$strQueryWHERE."
				HAVING
					1
					".$strQueryHAVING."
				ORDER BY
					".$strQueryORDER."		
				".$strLimit."
			";

            $arProductgroupIDs = $GLOBALS['wpsg_db']->fetchAssocField($strQuery);
            $arReturn = array();

            foreach ($arProductgroupIDs as $productgroup_id) {

                $arReturn[$productgroup_id] = self::getInstance($productgroup_id);

            }

            return $arReturn;

        }

        public static function getQueryParts($arFilter = []) {

            $strQuerySELECT = "";
            $strQueryWHERE = "";
            $strQueryJOIN = "";
            $strQueryHAVING = "";
            $strQueryORDER = " `id` ASC ";

            return [$strQuerySELECT, $strQueryWHERE, $strQueryJOIN, $strQueryHAVING, $strQueryORDER];

        }

    }